Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs	(revision 10699)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs	(revision 10700)
@@ -47,5 +47,5 @@
       foreach (IFilter filter in e.Items)
       {
-        if (!filter.Active && (filter.ConstrainedValue == null || filter.ConstraintData == null || filter.ConstraintOperation == null))
+        if (!filter.Active && (filter.ConstrainedValue == null || filter.ConstraintData == null  || filter.ConstraintOperation == null))
         {
           filterView.Content.SetItemCheckedState(filter, false);
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj	(revision 10699)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HeuristicLab.DataPreprocessing.Views-3.3.csproj	(revision 10700)
@@ -110,10 +110,4 @@
       <DependentUpon>PreprocessingChartView.cs</DependentUpon>
     </Compile>
-    <Compile Include="PreprocessingCheckedItemListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="PreprocessingCheckedItemListView.Designer.cs">
-      <DependentUpon>PreprocessingCheckedItemListView.cs</DependentUpon>
-    </Compile>
     <Compile Include="PreprocessingDataTableView.cs">
       <SubType>UserControl</SubType>
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingCheckedItemListView.Designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingCheckedItemListView.Designer.cs	(revision 10699)
+++ 	(revision )
@@ -1,32 +1,0 @@
-﻿namespace HeuristicLab.DataPreprocessing.Views {
-  partial class PreprocessingCheckedItemListView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-    }
-
-    #endregion
-  }
-}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingCheckedItemListView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingCheckedItemListView.cs	(revision 10699)
+++ 	(revision )
@@ -1,45 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.DataPreprocessing.Views {
-
-  [View("PreprocessingCheckedItemList View")]
-  [Content(typeof(CheckedItemList<StringValue>), true)]
-  [Content(typeof(ICheckedItemList<StringValue>), true)]
-  public partial class PreprocessingCheckedItemListView : CheckedItemListView<StringValue> {
-
-    public new ICheckedItemList<StringValue> Content {
-      get { return (ICheckedItemList<StringValue>)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public PreprocessingCheckedItemListView()
-      : base() {
-      InitializeComponent();
-      DisableDetails();     
-    }
-
-    private void DisableDetails() {
-        splitContainer.Panel2Collapsed = true;
-        viewHost.Content = null;
-        showDetailsCheckBox.Visible = false;
-        
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
-  }
-
-
-}