Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10712)
@@ -102,5 +102,4 @@
             break;
         }
-
       }
     }
@@ -160,6 +159,5 @@
 
     void findAndReplaceDialog_ReplaceEvent(object sender, EventArgs e) {
-      if (searchIterator != null && searchIterator.GetCurrent() != null)
-      {
+      if (searchIterator != null && searchIterator.GetCurrent() != null) {
         Replace(TransformToDictionary(currentCell));
       }
@@ -175,5 +173,5 @@
         currentSearchText = findAndReplaceDialog.GetSearchText();
       }
-      
+
       bool moreOccurences = false;
       do {
@@ -294,5 +292,5 @@
         e.Graphics.FillRectangle(backColorBrush, bounds);
       }
-      
+
       using (Brush gridBrush = new SolidBrush(Color.LightGray)) {
         Pen gridLinePen = new Pen(gridBrush);
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/FilterView.cs	(revision 10712)
@@ -1,27 +1,20 @@
 ﻿using System;
 using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
 using System.Linq;
-using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
 using HeuristicLab.Core.Views;
+using HeuristicLab.Data;
+using HeuristicLab.DataPreprocessing.Filter;
 using HeuristicLab.MainForm;
-using HeuristicLab.Core;
-using HeuristicLab.DataPreprocessing.Filter;
-using HeuristicLab.Collections;
-using HeuristicLab.Data;
 
-namespace HeuristicLab.DataPreprocessing.Views
-{
+namespace HeuristicLab.DataPreprocessing.Views {
   [View("CheckedFilterCollection View")]
-  [Content(typeof(FilterContent), false)]
-  public partial class FilterView : ItemView
-  {
+  [Content(typeof(FilterContent), true)]
+  public partial class FilterView : ItemView {
     private CheckedItemCollectionView<IFilter> filterView;
 
-    public FilterView()
-    {
+    public FilterView() {
       InitializeComponent();
       tbTotal.Text = "0";
@@ -37,17 +30,13 @@
     }
 
-    public new FilterContent Content
-    {
+    public new FilterContent Content {
       get { return (FilterContent)base.Content; }
-      set { base.Content = value;}
+      set { base.Content = value; }
     }
 
-    private void Content_CheckedItemsChanged(object sender, Collections.CollectionItemsChangedEventArgs<IFilter> e)
-    {
-      
-      foreach (IFilter filter in e.Items)
-      {
-        if (filterView.Content.CheckedItems.Contains(filter) && (filter.ConstraintData == null || string.IsNullOrEmpty(((StringValue)filter.ConstraintData).Value)) )
-        {
+    private void Content_CheckedItemsChanged(object sender, Collections.CollectionItemsChangedEventArgs<IFilter> e) {
+
+      foreach (IFilter filter in e.Items) {
+        if (filterView.Content.CheckedItems.Contains(filter) && (filter.ConstraintData == null || string.IsNullOrEmpty(((StringValue)filter.ConstraintData).Value))) {
           filter.ConstraintData = new StringValue("0");
         }
@@ -59,6 +48,5 @@
     }
 
-    private void UpdateFilterInfo()
-    {
+    private void UpdateFilterInfo() {
       List<IFilter> filters = filterView.ItemCollection.ToList<IFilter>();
 
@@ -68,7 +56,7 @@
 
       bool[] result = Content.FilterLogic.Preview(filters);
-      
+
       int filteredCnt = result.Count(c => !c);
-  
+
       tbFiltered.Text = filteredCnt.ToString();
       double percentage = filteredCnt * 100 / result.Length;
@@ -77,6 +65,5 @@
     }
 
-    private void applyFilterButton_Click(object sender, EventArgs e)
-    {
+    private void applyFilterButton_Click(object sender, EventArgs e) {
       List<IFilter> filters = filterView.ItemCollection.ToList<IFilter>();
       Content.FilterLogic.Apply(filters);
@@ -84,8 +71,6 @@
 
     //whenever a new filter is added the preprocessing data is set to the filter
-    private void Content_ItemsAdded(object sender, Collections.CollectionItemsChangedEventArgs<IFilter> e)
-    {
-      foreach (IFilter filter in e.Items)
-      {
+    private void Content_ItemsAdded(object sender, Collections.CollectionItemsChangedEventArgs<IFilter> e) {
+      foreach (IFilter filter in e.Items) {
         filter.ConstrainedValue = Content.FilterLogic.PreprocessingData;
         filter.Active = true;
@@ -95,6 +80,5 @@
     }
 
-    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IFilter> e)
-    {
+    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IFilter> e) {
       UpdateFilterInfo();
     }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/HistogramView.cs	(revision 10712)
@@ -1,15 +1,4 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
+﻿using System.Windows.Forms;
 using HeuristicLab.Analysis;
-using HeuristicLab.Collections;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
 using HeuristicLab.MainForm;
 
@@ -17,5 +6,5 @@
 
   [View("Histogram View")]
-  [Content(typeof(HistogramContent), false)]
+  [Content(typeof(HistogramContent), true)]
   public partial class HistogramView : PreprocessingChartView {
 
@@ -33,7 +22,4 @@
     }
 
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/LineChartView.cs	(revision 10712)
@@ -27,5 +27,5 @@
 
   [View("Line Chart View")]
-  [Content(typeof(LineChartContent), false)]
+  [Content(typeof(LineChartContent), true)]
   public partial class LineChartView : PreprocessingChartView {
 
@@ -42,8 +42,4 @@
       set { base.Content = value; }
     }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/ManipulationView.cs	(revision 10712)
@@ -29,5 +29,5 @@
 
   [View("Manipulation Chart View")]
-  [Content(typeof(ManipulationContent), false)]
+  [Content(typeof(ManipulationContent), true)]
   public partial class ManipulationView : ItemView {
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/PreprocessingChartView.cs	(revision 10712)
@@ -36,5 +36,5 @@
     private IChartLogic logic;
     private DataTable dataTable;
-    private ICheckedItemList<StringValue> variableItemList;    
+    private ICheckedItemList<StringValue> variableItemList;
     protected DataRowVisualProperties.DataRowChartType chartType;
     protected string chartTitle;
@@ -50,6 +50,5 @@
 
     private void CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<StringValue>> checkedItems) {
-      foreach(IndexedItem<StringValue> item in checkedItems.Items)
-      {
+      foreach (IndexedItem<StringValue> item in checkedItems.Items) {
         string variableName = item.Value.Value;
         if (VariableIsDisplayed(variableName)) {
@@ -122,5 +121,5 @@
         case DataPreprocessingChangedEventType.ChangeItem:
           dataTable.Rows.Remove(logic.GetVariableNameByIndex(e.Column));
-          dataTable.Rows.Add(logic.CreateDataRow(logic.GetVariableNameByIndex(e.Column),chartType));
+          dataTable.Rows.Add(logic.CreateDataRow(logic.GetVariableNameByIndex(e.Column), chartType));
           break;
         case DataPreprocessingChangedEventType.DeleteRow:
@@ -155,5 +154,4 @@
     }
 
-
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/StatisticsView.cs	(revision 10712)
@@ -29,5 +29,5 @@
 
   [View("Statistics View")]
-  [Content(typeof(StatisticsContent), false)]
+  [Content(typeof(StatisticsContent), true)]
   public partial class StatisticsView : ItemView {
 
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10710)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/TransformationView.cs	(revision 10712)
@@ -20,12 +20,12 @@
 #endregion
 
-using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.DataPreprocessing.Views {
 
   [View("Transformation View")]
-  [Content(typeof(TransformationContent), false)]
-  public partial class TransformationView : ItemView {
+  [Content(typeof(TransformationContent), true)]
+  public partial class TransformationView : AsynchronousContentView {
     public TransformationView() {
       InitializeComponent();
@@ -36,8 +36,4 @@
       set { base.Content = value; }
     }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
   }
 }