Index: branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10722)
+++ branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10723)
@@ -217,4 +217,10 @@
     </Compile>
     <Compile Include="Plugin.cs" />
+    <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapView.Designer.cs">
+      <DependentUpon>SlidingWindowBestSolutionsCollectionHeatMapView.cs</DependentUpon>
+    </Compile>
     <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapControl.cs">
       <SubType>UserControl</SubType>
@@ -222,10 +228,4 @@
     <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapControl.Designer.cs">
       <DependentUpon>SlidingWindowBestSolutionsCollectionHeatMapControl.cs</DependentUpon>
-    </Compile>
-    <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="SlidingWindowBestSolutionsCollectionHeatMapView.Designer.cs">
-      <DependentUpon>SlidingWindowBestSolutionsCollectionHeatMapView.cs</DependentUpon>
     </Compile>
     <Compile Include="SlidingWindowBestSolutionsCollectionView.cs">
@@ -349,9 +349,4 @@
   <ItemGroup>
     <Folder Include="Exporters\" />
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="SlidingWindowBestSolutionsCollectionView.resx">
-      <DependentUpon>SlidingWindowBestSolutionsCollectionView.cs</DependentUpon>
-    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapControl.cs
===================================================================
--- branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapControl.cs	(revision 10722)
+++ branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapControl.cs	(revision 10723)
@@ -31,5 +31,5 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  [View("Sliding Window Best Solutions HeatMap View")]
+  [View("Sliding Window Best Solutions HeatMap Control")]
   [Content(typeof(SlidingWindowBestSolutionsCollection), false)]
   public partial class SlidingWindowBestSolutionsCollectionHeatMapControl : ItemView {
@@ -108,13 +108,6 @@
         }
       }
-      int rows = values.GetLength(0);
-      int cols = values.GetLength(1);
-      var flipped = new double[rows, cols];
-      for (int i = 0; i < rows; ++i) {
-        for (int j = 0; j < cols; ++j) {
-          flipped[i, j] = values[rows - i - 1, j];
-        }
-      }
-      heatMapView.Content = new HeatMap(flipped, "Best Sliding Window Solutions", min, max);
+
+      heatMapView.Content = new HeatMap(values, string.Empty, min, max);
     }
 
Index: branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.Designer.cs
===================================================================
--- branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.Designer.cs	(revision 10723)
+++ branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.Designer.cs	(revision 10723)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  partial class SlidingWindowBestSolutionsCollectionHeatMapView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.cs
===================================================================
--- branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.cs	(revision 10723)
+++ branches/Sliding Window GP/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SlidingWindowBestSolutionsCollectionHeatMapView.cs	(revision 10723)
@@ -0,0 +1,19 @@
+﻿using System.Windows.Forms;
+using HeuristicLab.Analysis;
+using HeuristicLab.Analysis.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  [View("SlidingWindowBestSolutionCollectionHeatMapView")]
+  [Content(typeof(HeatMap), false)]
+  public partial class SlidingWindowBestSolutionsCollectionHeatMapView : HeatMapView {
+    public SlidingWindowBestSolutionsCollectionHeatMapView() {
+      InitializeComponent();
+
+      var chartArea = chart.ChartAreas[0];
+      chartArea.AxisX.Title = "Sliding window position";
+      chartArea.AxisY.Title = "Best solution";
+      chartArea.AxisY.IsReversed = true;
+    }
+  }
+}